/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.stimmeingabe;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.stimmeingabe.boundary.AbstractErgebniseingangSearchParameters;
import de.ivu.elect.business.stimmeingabe.boundary.ErgebniseingangChangeEvent;
import de.ivu.elect.business.stimmeingabe.boundary.ErgebniseingangConversationStore;
import de.ivu.elect.business.stimmeingabe.boundary.ErgebniseingangExtendedDAO;
import de.ivu.elect.business.stimmeingabe.boundary.ErgebniseingangSearch;
import de.ivu.elect.business.stimmeingabe.boundary.ErgebniseingangSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang;
import de.ivu.elect.business.stimmeingabe.entity.ErgebniseingangMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractErgebniseingangSearchView.COMPONENT_NAME)
@View(viewId = AbstractErgebniseingangSearchView.VIEW_ID, useCase = UseCasePermission.ERGEBNISEINGANG_SEARCH)
public abstract class AbstractErgebniseingangSearchView extends AbstractElectSearchView<Ergebniseingang> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "ergebniseingangSearchView";
  
  public static final String VIEW_ID = "/stimmeingabe/ergebniseingang-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractErgebniseingangSearchView requestHandler;

  @Inject
  private transient ErgebniseingangExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(ErgebniseingangConversationStore.class)
  protected transient ErgebniseingangConversationStore conversationStore;

  @Inject
  protected transient ErgebniseingangSearch search;

  @Inject
  @ConversationGroup(AbstractErgebniseingangSearchParameters.class)
  protected transient ErgebniseingangSearchParameters searchParameters;

  @Inject
  protected transient ErgebniseingangMeta entityMeta;

  public AbstractErgebniseingangSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Ergebniseingang getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Ergebniseingang entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public ErgebniseingangSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Ergebniseingang> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Ergebniseingang> create();
  }

  @Override
  public List<Ergebniseingang> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Ergebniseingang> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onErgebniseingangChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) ErgebniseingangChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractErgebniseingangSearchView {

    @View
    @Inject
    private transient Instance<AbstractErgebniseingangSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractErgebniseingangSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
